import Vue from "vue";
import Vuex from "vuex";

Vue.use(Vuex);

const examHomeModule = {
  namespaced: true,
  state: { faceCheckModalOpen: false },
  mutations: {
    toggleFaceCheckModal(state, open) {
      if (open === undefined) {
        state.faceCheckModalOpen = !state.faceCheckModalOpen;
      } else {
        state.faceCheckModalOpen = open;
      }
    }
  },
  actions: {},
  getters: {}
};

const examingHomeModule = {
  namespaced: true,
  state: {
    exam: null,
    paperStruct: null,
    examQuestionList: null,
    questionFilterType: "ALL",
    snapNow: false,
    shouldSubmitPaper: false
  },
  mutations: {
    toggleSnapNow(state) {
      state.snapNow = !state.snapNow;
    },
    updateExamState(state, payload) {
      state = Object.assign(state, payload);
    },
    updateQuestionFilter(state, type) {
      state.questionFilterType = type;
    },
    updateExamQuestionAnswer(state, { order, studentAnswer }) {
      state.examQuestionList = state.examQuestionList.map(eq => {
        if (eq.order === order) {
          return Object.assign({}, eq, { studentAnswer });
        }
        return eq;
      });
    },
    shouldSubmitPaper(state) {
      state.shouldSubmitPaper = !state.shouldSubmitPaper;
    }
  },
  actions: {},
  getters: {
    // FIXME: 不需要了
    validQuestions: state => {
      return state.examQuestionList;
    }
  }
};

let initUser = {};
if (process.env.NODE_ENV !== "production") {
  const userStr = window.localStorage.getItem("user");
  initUser = JSON.parse(userStr);
}

export default new Vuex.Store({
  state: {
    user: initUser
  },
  mutations: {},
  actions: {},
  modules: {
    examHomeModule,
    examingHomeModule
  }
});
